import { Request, Response, NextFunction } from 'express';
import { CryptoSession } from './session.js';
import { Token } from './token.js';
declare global {
    namespace Express {
        interface Request {
            token: Token;
            session: CryptoSession;
            isAuthenticated: boolean;
        }
        interface Response {
            secure: SecuredSend;
        }
    }
}
export interface SecuredSend {
    send: (payload: string) => Promise<Response>;
    json: (payload: object) => Promise<Response>;
}
export declare function useAuthWithExpress(req: Request, res: Response, next: NextFunction): Promise<void | Response<any, Record<string, any>>>;
export declare function useAuthWithNext(handler: Function): unknown;
export declare function useCryptoSession(req: Request, res: Response): Promise<void>;
declare function getSessionToken(req: Request, res: Response): Promise<void>;
declare function verifyRequest(req: Request, payload: any): Promise<boolean>;
declare function decodeRequest(req: Request, payload: any): Promise<boolean>;
declare function setSecuredResponse(req: Request, res: Response): void;
export declare const MidwareUtils: {
    getSessionToken: typeof getSessionToken;
    verifyRequest: typeof verifyRequest;
    decodeRequest: typeof decodeRequest;
    setSecuredResponse: typeof setSecuredResponse;
};
export {};
//# sourceMappingURL=middleware.d.ts.map